aboutsummaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authorDenys Vlasenko <vda.linux@googlemail.com>2016-04-21 16:26:30 +0200
committerDenys Vlasenko <vda.linux@googlemail.com>2016-04-21 17:39:11 +0200
commite6a2f4cc5a47d3022bdf5ca2cacbaa5a8c5baf7a (patch)
tree0962142ac9830312cd3df52994db41e8ac47c73c /scripts
parent5598bdf0d3d46a865a4d23785e2d09e6db9be420 (diff)
downloadbusybox-e6a2f4cc5a47d3022bdf5ca2cacbaa5a8c5baf7a.tar.gz
libbb: make bb_common_bufsiz1 1 kbyte, add capability to use bss tail for it
The config item is FEATURE_USE_BSS_TAIL. When it is off (default): function old new delta read_config 210 228 +18 doCommands 2279 2294 +15 ipneigh_list_or_flush 763 772 +9 ipaddr_list_or_flush 1256 1261 +5 display_process_list 1301 1306 +5 conspy_main 1378 1383 +5 do_lzo_compress 352 355 +3 do_lzo_decompress 565 567 +2 push 46 44 -2 inetd_main 2136 2134 -2 uevent_main 421 418 -3 addLines 97 92 -5 bb_common_bufsiz1 8193 1024 -7169 ------------------------------------------------------------------------------ (add/remove: 0/0 grow/shrink: 8/5 up/down: 62/-7181) Total: -7119 bytes text data bss dec hex filename 829850 4086 9080 843016 cdd08 busybox_old 829901 4086 1904 835891 cc133 busybox_unstripped FEATURE_USE_BSS_TAIL=y: read_config 210 228 +18 doCommands 2279 2294 +15 ipneigh_list_or_flush 763 772 +9 ipaddr_list_or_flush 1256 1261 +5 display_process_list 1301 1306 +5 conspy_main 1378 1383 +5 do_lzo_compress 352 355 +3 do_lzo_decompress 565 567 +2 inetd_main 2136 2134 -2 bb_common_bufsiz1 8193 - -8193 ------------------------------------------------------------------------------ (add/remove: 0/1 grow/shrink: 8/1 up/down: 62/-8195) Total: -8133 bytes text data bss dec hex filename 829850 4086 9080 843016 cdd08 busybox_old 829911 4086 880 834877 cbd3d busybox_unstripped FIXME: setup_common_bufsiz() calls are missing. Signed-off-by: Denys Vlasenko <vda.linux@googlemail.com>
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/generate_BUFSIZ.sh114
1 files changed, 114 insertions, 0 deletions
diff --git a/scripts/generate_BUFSIZ.sh b/scripts/generate_BUFSIZ.sh
new file mode 100755
index 000000000..afe9eee1e
--- /dev/null
+++ b/scripts/generate_BUFSIZ.sh
@@ -0,0 +1,114 @@
+#!/bin/sh
+# Called from top-level directory a-la
+#
+# scripts/generate_BUFSIZ.sh include/common_bufsiz.h
+
+. ./.config || exit 1
+
+debug=false
+
+common_bufsiz_h=$1
+
+test x"$NM" = x"" && NM="${CONFIG_CROSS_COMPILER_PREFIX}nm"
+test x"$CC" = x"" && CC="${CONFIG_CROSS_COMPILER_PREFIX}gcc"
+
+regenerate() {
+ cat >"$1.$$"
+ test -f "$1" && diff "$1.$$" "$1" >/dev/null && rm "$1.$$" && return
+ mv "$1.$$" "$1"
+}
+
+generate_std_and_exit() {
+ $debug && echo "Default: bb_common_bufsiz1[] in bss"
+ {
+ echo "enum { COMMON_BUFSIZE = 1024 };"
+ echo "extern char bb_common_bufsiz1[];"
+ echo "#define setup_common_bufsiz() ((void)0)"
+ } | regenerate "$common_bufsiz_h"
+ exit 0
+}
+
+# User does not want any funky stuff?
+test x"$CONFIG_FEATURE_USE_BSS_TAIL" = x"y" || generate_std_and_exit
+
+test -f busybox_unstripped || {
+ # We did not try anything yet
+ $debug && echo "Will try to fit bb_common_bufsiz1[] into _end[]"
+ {
+ echo "enum { COMMON_BUFSIZE = 1024 };"
+ echo "extern char _end[]; /* linker-provided label */"
+ echo "#define bb_common_bufsiz1 _end"
+ echo "#define setup_common_bufsiz() ((void)0)"
+ } | regenerate "$common_bufsiz_h"
+ echo 1024 >"$common_bufsiz_h.BUFSIZE"
+ exit 0
+}
+
+# Get _end address
+END=`$NM busybox_unstripped | grep ' . _end$'| cut -d' ' -f1`
+test x"$END" = x"" && generate_std_and_exit
+$debug && echo "END:0x$END $((0x$END))"
+END=$((0x$END))
+
+# Get PAGE_SIZE
+echo "\
+#include <sys/user.h>
+#if defined(PAGE_SIZE) && PAGE_SIZE > 0
+char page_size[PAGE_SIZE];
+#else
+char page_size[1];
+#endif
+" >page_size_$$.c
+$CC -c "page_size_$$.c" || generate_std_and_exit
+PAGE_SIZE=`$NM --size-sort "page_size_$$.o" | cut -d' ' -f1`
+rm "page_size_$$.c" "page_size_$$.o"
+test x"$PAGE_SIZE" = x"" && generate_std_and_exit
+$debug && echo "PAGE_SIZE:0x$PAGE_SIZE $((0x$PAGE_SIZE))"
+PAGE_SIZE=$((0x$PAGE_SIZE))
+test $PAGE_SIZE -lt 1024 && generate_std_and_exit
+
+# How much space between _end[] and next page?
+PAGE_MASK=$((PAGE_SIZE-1))
+REM=$(( (-END) & PAGE_MASK ))
+$debug && echo "REM:$REM"
+
+if test $REM -lt 1024; then
+ # _end[] has no enough space for bb_common_bufsiz1[],
+ # users will need to malloc it.
+ {
+ echo "enum { COMMON_BUFSIZE = 1024 };"
+ echo "extern char *bb_common_bufsiz1;"
+ echo "void setup_common_bufsiz(void);"
+ } | regenerate "$common_bufsiz_h"
+ # Check that we aren't left with a buggy binary:
+ if test -f "$common_bufsiz_h.BUFSIZE"; then
+ rm "$common_bufsiz_h.BUFSIZE"
+ echo "Warning! Space in _end[] is too small ($REM bytes)!"
+ echo "Rerun make to build a binary which doesn't use it!"
+ exit 1
+ fi
+ exit 0
+fi
+
+# _end[] has REM bytes for bb_common_bufsiz1[]
+OLD=1024
+test -f "$common_bufsiz_h.BUFSIZE" && OLD=`cat "$common_bufsiz_h.BUFSIZE"`
+$debug && echo "OLD:$OLD"
+{
+echo "enum { COMMON_BUFSIZE = $REM };"
+echo "extern char _end[]; /* linker-provided label */"
+echo "#define bb_common_bufsiz1 _end"
+echo "#define setup_common_bufsiz() ((void)0)"
+} | regenerate "$common_bufsiz_h"
+echo $REM >"$common_bufsiz_h.BUFSIZE"
+
+# Check that code did not grow too much and thus _end[] did not shink:
+if test $OLD -gt $REM; then
+ echo "Warning! Space in _end[] has decreased from $OLD to $REM bytes!"
+ echo "Rerun make!"
+ exit 1
+fi
+
+if test $OLD != $REM; then
+ echo "Space in _end[] is $REM bytes. Rerun make to use larger COMMON_BUFSIZE."
+fi